# Copyright (C) 2018-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

# * The software is provided "as is" without any warranty, neither express
#   nor implied.
# * In no event will the author be held liable for any damage(s) arising
#   from the use of the software.
# * Redistribution of the software is allowed only in unmodified form.
# * Permission is granted to use the software solely for personal private
#   and non-commercial purposes.
# * An individuals use of the software in his or her capacity or function
#   as an agent, (independent) contractor, employee, member or officer of
#   a business, corporation or organization (commercial or non-commercial)
#   does not qualify as personal private and non-commercial purpose.
# * Without written approval from the author the software must not be used
#   for a business, for commercial, corporate, governmental, military or
#   organizational purposes of any kind, or in a commercial, corporate,
#   governmental, military or organizational environment of any kind.

.SUFFIXES:

test: MELTDOWN.EXE SPECTRE.EXE VARIANT4.EXE
	MELTDOWN.EXE
	SPECTRE.EXE
	VARIANT4.EXE

sign: MELTDOWN.EXE SPECTRE.EXE VARIANT4.EXE
	SIGNTOOL.EXE Sign /A /D "Meltdown/Spectre/Spectre-NG Update Check Utility" /DU "https://skanthak.hier-im-netz.de/spectre.html" /N "Stefan Kanthak" /T "http://timestamp.digicert.com/" /V $**
#	SIGNTOOL.EXE Sign /AS /D "Meltdown/Spectre/Spectre-NG Update Check Utility" /DU "https://skanthak.hier-im-netz.de/spectre.html" /FD SHA256 /N "Stefan Kanthak" /TD SHA256 /TR "http://timestamp.digicert.com/" /V $**

clobber: clean
	Erase MELTDOWN.EXE SPECTRE.EXE VARIANT4.EXE

clean:
	Erase GIMMICK.EXP GIMMICK.LIB GIMMICK.OBJ
	Erase MELTDOWN.OBJ MELTDOWN.RES
	Erase SPECTRE.OBJ SPECTRE.RES
	Erase VARIANT4.OBJ VARIANT4.RES

GIMMICK.LIB: GIMMICK.OBJ
	LINK.EXE /LIB /BREPRO /DEF /EXPORT:_snwprintf /EXPORT:NtQuerySystemInformation /EXPORT:NtRaiseHardError /EXPORT:NtTerminateProcess /NAME:NTDLL /NODEFAULTLIB /NOLOGO /OUT:$@ $**

GIMMICK.OBJ: GIMMICK.MAK
	CL.EXE /Brepro /c /Fo$@ /Gz /nologo /Tc<< /W4 /wd4100 /X /Zl
// Copyright (C) 2018-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

__declspec(dllexport)
long	__cdecl		_snwprintf(void *_1, long _2, void *_3, ...)
{ return 0; }

__declspec(dllexport)
long	NtQuerySystemInformation(long _1, void *_2, long _3, void *_4)
{ return 0; }

__declspec(dllexport)
long	NtRaiseHardError(long _1, long _2, long _3, void *_4, long _5, void *_6)
{ return 0; }

__declspec(dllexport)
long	NtTerminateProcess(void *_1, long _2)
{ return 0; }
<<NOKEEP

MELTDOWN.EXE SPECTRE.EXE VARIANT4.EXE: $*.RES $*.OBJ GIMMICK.LIB
	LINK.EXE /LINK /BASE:65536 /BREPRO /DYNAMICBASE /EMITTOOLVERSIONINFO:NO /ENTRY:wWinMainCRTStartup /LARGEADDRESSAWARE /MERGE:.rdata=.const /MERGE:.text=.code /NOCOFFGRPINFO /NODEFAULTLIB /NOLOGO /NXCOMPAT /OPT:REF /OSVERSION:5.0 /OUT:$@ /RELEASE /SUBSYSTEM:WINDOWS /SWAPRUN:CD,NET /VERSION:0.815 $**

MELTDOWN.OBJ SPECTRE.OBJ VARIANT4.OBJ: GIMMICK.MAK
	CL.EXE /Brepro /c /D$* /Fo$@ /GA /GF /GS- /Gw /Gy /nologo /O1 /Os /Tc<< /W4 /wd4214 /we4013 /Zl
// Copyright (C) 2018-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

// https://msdn.microsoft.com/en-us/library/aa383732.aspx

#define STRICT
#define UNICODE
#define WIN32_LEAN_AND_MEAN

#include <windows.h>

// https://msdn.microsoft.com/en-us/library/cc231200.aspx
// https://msdn.microsoft.com/en-us/library/cc704588.aspx

typedef	enum	_NTSTATUS
{
	STATUS_SUCCESS              = 0x00000000,
	STATUS_SERVICE_NOTIFICATION = 0x40000018,
	STATUS_UNSUCCESSFUL         = 0xC0000001,
	STATUS_NOT_IMPLEMENTED      = 0xC0000002,
	STATUS_INVALID_INFO_CLASS   = 0xC0000003,
	STATUS_INFO_LENGTH_MISMATCH = 0xC0000004
} NTSTATUS;

typedef	enum	_SYSTEM_INFORMATION_CLASS
{
	SystemKernelVaShadowInformation     = 196,
	SystemSpeculationControlInformation = 201
} SYSTEM_INFORMATION_CLASS;

// https://msdn.microsoft.com/en-us/library/ms724509.aspx

__declspec(dllimport)
NTSTATUS	NTAPI	NtQuerySystemInformation(SYSTEM_INFORMATION_CLASS SystemInformationClass,
			                         LPVOID                   SystemInformation,
			                         DWORD                    SystemInformationLength,
			                         LPDWORD                  ReturnLength);

// https://msdn.microsoft.com/en-us/library/2ts7cx93.aspx

__declspec(dllimport)
LONG	CDECL	_snwprintf(LPWSTR buffer, SIZE_T count, LPCWSTR format, ...);

// https://msdn.microsoft.com/en-us/library/aa380518.aspx
// https://msdn.microsoft.com/en-us/library/ff564879.aspx

typedef	struct	_UNICODE_STRING
{
	WORD	Length;
	WORD	MaximumLength;
	LPWSTR	Buffer;
} UNICODE_STRING, *LPUNICODE_STRING, *PUNICODE_STRING;

static	WCHAR	szMessage[1025] = L"";
#if MELTDOWN
const	WCHAR	szCaption[] = L"\"Meltdown\" (CVE-2017-5754 [Rogue Data Cache Load])";
#elif SPECTRE
const	WCHAR	szCaption[] = L"\"Spectre\" (CVE-2017-5715 [Branch Target Injection] & CVE-2017-5753 [Bounds Check Bypass])";
#elif VARIANT4
const	WCHAR	szCaption[] = L"\"Variant 4\" (CVE-2018-3639 [Speculative Store Bypass])";
#else
#error Either MELTDOWN, SPECTRE or VARIANT4 must be defined!
#endif

static	UNICODE_STRING	usMessage = {sizeof(szMessage), sizeof(szMessage) - sizeof(*szMessage), szMessage};
const	UNICODE_STRING	usCaption = {sizeof(szCaption), sizeof(szCaption) - sizeof(*szCaption), szCaption};

typedef	enum	_HARDERROR_RESPONSE_OPTION
{
	OptionAbortRetryIgnore,
	OptionOk,
	OptionOkCancel,
	OptionRetryCancel,
	OptionYesNo,
	OptionYesNoCancel,
	OptionShutdownSystem,
	OptionOkNoWait,		// balloon notification!
	OptionCancelTryContinue
} HARDERROR_RESPONSE_OPTION;

typedef	enum	_HARDERROR_RESPONSE
{
	ResponseReturnToCaller,
	ResponseNotHandled,
	ResponseAbort,
	ResponseCancel,
	ResponseIgnore,
	ResponseNo,
	ResponseOk,
	ResponseRetry,
	ResponseYes,
	ResponseTryAgain,
	ResponseContinue
} HARDERROR_RESPONSE;

__declspec(dllimport)
NTSTATUS	NTAPI	NtRaiseHardError(NTSTATUS                  ErrorStatus,
			                 DWORD                     NumberOfParameters,
			                 DWORD                     UnicodeStringParameterMask,
			                 DWORD_PTR                 *Parameters,
			                 HARDERROR_RESPONSE_OPTION ValidResponseOptions,
			                 HARDERROR_RESPONSE        *Response);

#define MAXIMUM_HARDERROR_PARAMETERS	5

#define HARDERROR_PARAMETERS_FLAGSPOS	4
#define HARDERROR_FLAGS_DEFDESKTOPONLY	0x00020000UL

// NOTE: Parameters[3] holds the timeout in milliseconds!

#define HARDERROR_OVERRIDE_ERRORMODE	0x10000000UL

const	DWORD_PTR	heParameters[] = {&usMessage, &usCaption, 0L};

// https://msdn.microsoft.com/en-us/library/ff557699.aspx

__declspec(dllimport)
NTSTATUS	NTAPI	NtTerminateProcess(HANDLE   ProcessHandle,
			                   NTSTATUS ExitStatus);

// https://msdn.microsoft.com/en-us/library/ff556482.aspx

__forceinline
HANDLE	NTAPI	NtCurrentProcess(VOID)
{
#ifdef _WIN64
	return (HANDLE) -1LL;
#else
	return (HANDLE) -1L;
#endif
}

// https://msdn.microsoft.com/en-us/library/f9t8842e.aspx

__declspec(noreturn)
VOID	CDECL	wWinMainCRTStartup(VOID)
{
	HARDERROR_RESPONSE	heResponse;

	// https://msdn.microsoft.com/en-us/library/ms724509.aspx
#if MELTDOWN
	struct
	{
		DWORD	KvaShadowEnabled : 1;			// Kernel Virtual Address Shadowing enabled
		DWORD	KvaShadowUserGlobal : 1;		// Kernel Virtual Address Shadowing enabled on user pages marked global
		DWORD	KvaShadowPcid : 1;			// PCID support (Westmere and later)
		DWORD	KvaShadowInvpcid : 1;			// INVPCID support (Haswell and later)
		DWORD	KvaShadowRequired : 1;
		DWORD	KvaShadowRequiredAvailable : 1;
		DWORD	InvalidPteBit : 6;
		DWORD	L1DataCacheFlushSupported : 1;
		DWORD	L1TerminalFaultMitigationPresent : 1;
		DWORD	Reserved : 18;
	} KvaShadowFlags;
#else
	struct
	{
		DWORD	BpbEnabled : 1;				// Branch target injection protection enabled
		DWORD	BpbDisabledSystemPolicy : 1;		// PolicyOverride/PolicyOverrideMask registry setting
		DWORD	BpbDisabledNoHardwareSupport : 1;	// Microcode update not installed
		DWORD	SpecCtrlEnumerated : 1;			// IA32_SPEC_CTRL MSR support
		DWORD	SpecCmdEnumerated : 1;			// IA32_PRED_CMD MSR support (IBPB)
		DWORD	IbrsPresent : 1;			// IBRS support (Indirect Branch Restricted Speculation)
		DWORD	StibpPresent : 1;			// STIPB support (Single Thread Indirect Branch Predictors)
		DWORD	SmepPresent : 1;			// SMEP support (Supervisor-Mode Execution Prevention)
		DWORD	SpeculativeStoreBypassDisableAvailable : 1;
		DWORD	SpeculativeStoreBypassDisableSupported : 1;
		DWORD	SpeculativeStoreBypassDisabledSystemWide : 1;
		DWORD	SpeculativeStoreBypassDisabledKernel : 1;
		DWORD	SpeculativeStoreBypassDisableRequired : 1;
		DWORD	BpbDisabledKernelToUser : 1;
		DWORD	SpecCtrlRetpolineEnabled : 1;
		DWORD	SpecCtrlImportOptimizationEnabled : 1;
		DWORD	EnhancedIbrs : 1;
		DWORD	HvL1tfStatusAvailable : 1;
		DWORD	HvL1tfProcessorNotAffected : 1;
		DWORD	HvL1tfMigitationEnabled : 1;
		DWORD	HvL1tfMigitationNotEnabled_Hardware : 1;
		DWORD	HvL1tfMigitationNotEnabled_LoadOption : 1;
		DWORD	HvL1tfMigitationNotEnabled_CoreScheduler : 1;
		DWORD	EnhancedIbrsReported : 1;
		DWORD	MdsHardwareProtected : 1;
		DWORD	MbClearEnabled : 1;
		DWORD	MbClearReported : 1;
		DWORD	Reserved : 5;
	} SpeculationControlFlags;
#endif
	LONG		nlMessage;
#if MELTDOWN
	NTSTATUS	ntStatus = NtQuerySystemInformation(SystemKernelVaShadowInformation,
			                                    &KvaShadowFlags,
			                                    sizeof(KvaShadowFlags),
			                                    (LPDWORD) NULL);

	if (ntStatus < 0)
		nlMessage = _snwprintf(szMessage,
		                       sizeof(szMessage) / sizeof(*szMessage),
		                       L"NtQuerySystemInformation(SystemKernelVaShadowInformation) returned status 0x%08lX\n"
		                       L"\n"
		                       L"Summary information:\n"
		                       L"\tMitigation for \"Meltdown\" (CVE-2017-5754 [Rogue Data Cache Load]) is not installed!\n"
		                       L"\n"
		                       L"Notes:\t0xC0000002 (STATUS_NOT_IMPLEMENTED) indicates that security update KB405689x is installed, but does not support this information request!\n"
		                       L"\t0xC0000003 (STATUS_INVALID_INFO_CLASS) indicates that security update KB405689x is not installed!\n",
		                       ntStatus);
	else
		nlMessage = _snwprintf(szMessage,
		                       sizeof(szMessage) / sizeof(*szMessage),
		                       L"NtQuerySystemInformation(SystemKernelVaShadowInformation) returned status 0x%08lX\n"
		                       L"\n"
		                       L"Summary information:\n"
		                       L"\tMitigation for \"Meltdown\" (CVE-2017-5754 [Rogue Data Cache Load]) is%ls enabled!\n"
		                       L"\n"
		                       L"Detail information:\n"
		                       L"\tKvaShadowFlags = 0x%08lX\n"
		                       L"\t%lc\tKvaShadowEnabled\n"
		                       L"\t\t(Mitigation enabled by Windows)\n"
		                       L"\t%lc\tKvaShadowUserGlobal\n"
		                       L"\t%lc\tKvaShadowPcid\n"
		                       L"\t\t(Processor supports PCID feature)\n"
		                       L"\t%lc\tKvaShadowInvpcid\n"
		                       L"\t\t(Processor supports INVPCID instruction)\n"
		                       L"\t%lc\tKvaShadowRequired\n"
		                       L"\t%lc\tKvaShadowRequiredAvailable\n"
		                       L"\t%lc\tL1DataCacheFlushSupported\n"
		                       L"\t%lc\tL1TerminalFaultMitigationPresent\n",
		                       ntStatus,
		                       KvaShadowFlags.KvaShadowEnabled ? L"" : L" not",
		                       *(LPDWORD) &KvaShadowFlags,
		                       L'0' + KvaShadowFlags.KvaShadowEnabled,
		                       L'0' + KvaShadowFlags.KvaShadowUserGlobal,
		                       L'0' + KvaShadowFlags.KvaShadowPcid,
		                       L'0' + KvaShadowFlags.KvaShadowInvpcid,
		                       L'0' + KvaShadowFlags.KvaShadowRequired,
		                       L'0' + KvaShadowFlags.KvaShadowRequiredAvailable,
		                       L'0' + KvaShadowFlags.L1DataCacheFlushSupported,
		                       L'0' + KvaShadowFlags.L1TerminalFaultMitigationPresent);
#elif SPECTRE
	NTSTATUS	ntStatus = NtQuerySystemInformation(SystemSpeculationControlInformation,
			                                    &SpeculationControlFlags,
			                                    sizeof(SpeculationControlFlags),
			                                    (LPDWORD) NULL);

	if (ntStatus < 0)
		nlMessage = _snwprintf(szMessage,
		                       sizeof(szMessage) / sizeof(*szMessage),
		                       L"NtQuerySystemInformation(SystemSpeculationControlInformation) returned status 0x%08lX\n"
		                       L"\n"
		                       L"Summary information:\n"
		                       L"\tMitigation for \"Spectre\" (CVE-2017-5715 [Branch Target Injection] and CVE-2017-5753 [Bounds Check Bypass]) is not installed!\n"
		                       L"\n"
		                       L"Notes:\t0xC0000002 (STATUS_NOT_IMPLEMENTED) indicates that security update KB405689x is installed, but does not support this information request!\n"
		                       L"\t0xC0000003 (STATUS_INVALID_INFO_CLASS) indicates that security update KB405689x is not installed!\n",
		                       ntStatus);
	else
		nlMessage = _snwprintf(szMessage,
		                       sizeof(szMessage) / sizeof(*szMessage),
		                       L"NtQuerySystemInformation(SystemSpeculationControlInformation) returned status 0x%08lX\n"
		                       L"\n"
		                       L"Summary information:\n"
		                       L"\tMitigation for \"Spectre\" (CVE-2017-5715 [Branch Target Injection]) is%ls enabled!\n"
		                       L"\n"
		                       L"Detail information:\n"
		                       L"\tSpeculationControlFlags = 0x%08lX\n"
		                       L"\t%lc\tBpbEnabled\n"
		                    // L"\t\t(Mitigation enabled by Windows)\n"
		                       L"\t%lc\tBpbDisabledSystemPolicy\n"
		                    // L"\t\t(Mitigation disabled via Registry)\n"
		                       L"\t%lc\tBpbDisabledNoHardwareSupport\n"
		                    // L"\t\t(Microcode update missing)\n"
		                       L"\t%lc\tSpecCtrlEnumerated\n"
		                    // L"\t\t(Processor supports IA32_SPEC_CTRL MSR)\n"
		                       L"\t%lc\tSpecCmdEnumerated\n"
		                    // L"\t\t(Processor supports IA32_SPEC_CMD MSR)\n"
		                       L"\t%lc\tIbrsPresent\n"
		                    // L"\t\t(Processor supports IBRS feature)\n"
		                       L"\t%lc\tStibpPresent\n"
		                    // L"\t\t(Processor supports STIBP feature)\n"
		                       L"\t%lc\tSmepPresent\n"
		                    // L"\t\t(Processor supports SMEP feature)\n"
		                       L"\t%lc\tSsbdAvailable\n"
		                       L"\t%lc\tSsbdSupported\n"
		                       L"\t%lc\tSsbdSystemWide\n"
		                       L"\t%lc\tSsbdKernel\n"
		                       L"\t%lc\tSsbdRequired\n"
		                       L"\t%lc\tBpbDisabledKernelToUser\n"
		                       L"\t%lc\tSpecCtrlRetpolineEnabled\n"
		                       L"\t%lc\tSpecCtrlImportOptimizationEnabled\n",
		                       ntStatus,
		                       SpeculationControlFlags.BpbEnabled ? L"" : L" not",
		                       *(LPDWORD) &SpeculationControlFlags,
		                       L'0' + SpeculationControlFlags.BpbEnabled,
		                       L'0' + SpeculationControlFlags.BpbDisabledSystemPolicy,
		                       L'0' + SpeculationControlFlags.BpbDisabledNoHardwareSupport,
		                       L'0' + SpeculationControlFlags.SpecCtrlEnumerated,
		                       L'0' + SpeculationControlFlags.SpecCmdEnumerated,
		                       L'0' + SpeculationControlFlags.IbrsPresent,
		                       L'0' + SpeculationControlFlags.StibpPresent,
		                       L'0' + SpeculationControlFlags.SmepPresent,
		                       L'0' + SpeculationControlFlags.SpeculativeStoreBypassDisableAvailable,
		                       L'0' + SpeculationControlFlags.SpeculativeStoreBypassDisableSupported,
		                       L'0' + SpeculationControlFlags.SpeculativeStoreBypassDisabledSystemWide,
		                       L'0' + SpeculationControlFlags.SpeculativeStoreBypassDisabledKernel,
		                       L'0' + SpeculationControlFlags.SpeculativeStoreBypassDisableRequired,
		                       L'0' + SpeculationControlFlags.BpbDisabledKernelToUser,
		                       L'0' + SpeculationControlFlags.SpecCtrlRetpolineEnabled,
		                       L'0' + SpeculationControlFlags.SpecCtrlImportOptimizationEnabled);
#elif VARIANT4
	NTSTATUS	ntStatus = NtQuerySystemInformation(SystemSpeculationControlInformation,
			                                    &SpeculationControlFlags,
			                                    sizeof(SpeculationControlFlags),
			                                    (LPDWORD) NULL);

	if (ntStatus < 0)
		nlMessage = _snwprintf(szMessage,
		                       sizeof(szMessage) / sizeof(*szMessage),
		                       L"NtQuerySystemInformation(SystemSpeculationControlInformation) returned status 0x%08lX\n"
		                       L"\n"
		                       L"Summary information:\n"
		                       L"\tMitigation for \"Variant 4\" (CVE-2018-3639 [Speculative Store Bypass]) is not installed!\n"
		                       L"\n"
		                       L"Notes:\t0xC0000002 (STATUS_NOT_IMPLEMENTED) indicates that security update KB405689x is installed, but does not support this information request!\n"
		                       L"\t0xC0000003 (STATUS_INVALID_INFO_CLASS) indicates that security update KB405689x is not installed!\n",
		                       ntStatus);
	else
		nlMessage = _snwprintf(szMessage,
		                       sizeof(szMessage) / sizeof(*szMessage),
		                       L"NtQuerySystemInformation(SystemSpeculationControlInformation) returned status 0x%08lX\n"
		                       L"\n"
		                       L"Summary information:\n"
		                       L"\tMitigation for \"Variant 4\" (CVE-2018-3639 [Speculative Store Bypass]) is%ls enabled!\n"
		                       L"\n"
		                       L"Detail information:\n"
		                       L"\tSpeculationControlFlags = 0x%08lX\n"
		                       L"\t%lc\tBpbEnabled\n"
		                    // L"\t\t(Mitigation enabled by Windows)\n"
		                       L"\t%lc\tBpbDisabledSystemPolicy\n"
		                    // L"\t\t(Mitigation disabled via Registry)\n"
		                       L"\t%lc\tBpbDisabledNoHardwareSupport\n"
		                    // L"\t\t(Microcode update missing)\n"
		                       L"\t%lc\tSpecCtrlEnumerated\n"
		                    // L"\t\t(Processor supports IA32_SPEC_CTRL MSR)\n"
		                       L"\t%lc\tSpecCmdEnumerated\n"
		                    // L"\t\t(Processor supports IA32_SPEC_CMD MSR)\n"
		                       L"\t%lc\tIbrsPresent\n"
		                    // L"\t\t(Processor supports IBRS feature)\n"
		                       L"\t%lc\tStibpPresent\n"
		                    // L"\t\t(Processor supports STIBP feature)\n"
		                       L"\t%lc\tSmepPresent\n"
		                    // L"\t\t(Processor supports SMEP feature)\n"
		                       L"\t%lc\tSsbdAvailable\n"
		                       L"\t%lc\tSsbdSupported\n"
		                       L"\t%lc\tSsbdSystemWide\n"
		                       L"\t%lc\tSsbdKernel\n"
		                       L"\t%lc\tSsbdRequired\n"
		                       L"\t%lc\tBpbDisabledKernelToUser\n"
		                       L"\t%lc\tSpecCtrlRetpolineEnabled\n"
		                       L"\t%lc\tSpecCtrlImportOptimizationEnabled\n",
		                       ntStatus,
		                       SpeculationControlFlags.SpeculativeStoreBypassDisabledSystemWide ? L"" : L" not",
		                       *(LPDWORD) &SpeculationControlFlags,
		                       L'0' + SpeculationControlFlags.BpbEnabled,
		                       L'0' + SpeculationControlFlags.BpbDisabledSystemPolicy,
		                       L'0' + SpeculationControlFlags.BpbDisabledNoHardwareSupport,
		                       L'0' + SpeculationControlFlags.SpecCtrlEnumerated,
		                       L'0' + SpeculationControlFlags.SpecCmdEnumerated,
		                       L'0' + SpeculationControlFlags.IbrsPresent,
		                       L'0' + SpeculationControlFlags.StibpPresent,
		                       L'0' + SpeculationControlFlags.SmepPresent,
		                       L'0' + SpeculationControlFlags.SpeculativeStoreBypassDisableAvailable,
		                       L'0' + SpeculationControlFlags.SpeculativeStoreBypassDisableSupported,
		                       L'0' + SpeculationControlFlags.SpeculativeStoreBypassDisabledSystemWide,
		                       L'0' + SpeculationControlFlags.SpeculativeStoreBypassDisabledKernel,
		                       L'0' + SpeculationControlFlags.SpeculativeStoreBypassDisableRequired,
		                       L'0' + SpeculationControlFlags.BpbDisabledKernelToUser,
		                       L'0' + SpeculationControlFlags.SpecCtrlRetpolineEnabled,
		                       L'0' + SpeculationControlFlags.SpecCtrlImportOptimizationEnabled);
#else
#error Either MELTDOWN, SPECTRE or VARIANT4 must be defined!
#endif
	if (nlMessage >= 0L)
	{
		nlMessage *= sizeof(*szMessage);

		if (nlMessage >= sizeof(szMessage))
			nlMessage = sizeof(szMessage) - sizeof(*szMessage);

		usMessage.Length = (WORD) nlMessage;

		ntStatus = NtRaiseHardError(STATUS_SERVICE_NOTIFICATION,
#if 1
		                            sizeof(heParameters) / sizeof(*heParameters),
#else
		                            3UL,
#endif
		                            3UL,
		                            heParameters,
		                            0UL,
		                            &heResponse);
	}

	NtTerminateProcess(NtCurrentProcess(), ntStatus);
}
<<NOKEEP

MELTDOWN.RES: MELTDOWN.ICO GIMMICK.MAK
	RC.EXE /DUNICODE /Fo$@ /L 0 /N /R /V <<
// Copyright (C) 2018-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

// https://msdn.microsoft.com/en-us/library/aa383732.aspx

#define STRICT

#include <winnt.h>
#include <winuser.h>
#include <winver.h>

LANGUAGE LANG_NEUTRAL, SUBLANG_NEUTRAL

1 ICON "MELTDOWN.ICO"	// https://meltdownattack.com/favicon.ico

// https://msdn.microsoft.com/en-us/library/dn481241.aspx
// https://msdn.microsoft.com/en-us/library/dd371711.aspx

CREATEPROCESS_MANIFEST_RESOURCE_ID RT_MANIFEST
BEGIN
#ifdef UTF8BOM
    // https://msdn.microsoft.com/en-us/library/dd374101.aspx

    "\xEF\xBB\xBF"
#endif
    // BUG: the module loader fails with STATUS_SXS_CANT_GEN_ACTCTX
    //      when a valid encoding other than 'UTF-8' is specified!
#ifdef UTF8XML
    "<?xml version='1.0' encoding='UTF-8' standalone='yes' ?>\n"
#endif
    "<!-- Copyright (C) 2018-2024, Stefan Kanthak -->\n"
    "<assembly manifestVersion='1.0' xmlns='urn:schemas-microsoft-com:asm.v1'>\n"
    "    <assemblyIdentity name='eSKamation.Utility.Meltdown' processorArchitecture='*' type='win32' version='0.8.15.0' />\n"
    "    <compatibility xmlns='urn:schemas-microsoft-com:compatibility.v1'>\n"
    "        <application>\n"
    "            <supportedOS Id='{e2011457-1546-43c5-a5fe-008deee3d3f0}' />\n" // NT 6.0
    "            <supportedOS Id='{35138b9a-5d96-4fbd-8e2d-a2440225f93a}' />\n" // NT 6.1
    "            <supportedOS Id='{4a2f28e3-53b9-4441-ba9c-d69d4a4a6e38}' />\n" // NT 6.2
    "            <supportedOS Id='{1f676c76-80e1-4239-95bb-83d0f6d0da78}' />\n" // NT 6.3
    "            <supportedOS Id='{8e0f7a12-bfb3-4fe8-b9a5-48fd50a15a9a}' />\n" // NT 10
    "        </application>\n"
    "    </compatibility>\n"
    "    <description>Meltdown Update Check Utility</description>\n"
#if 0
    "    <trustInfo xmlns='urn:schemas-microsoft-com:asm.v2'>\n"
    "        <security>\n"
    "            <requestedPrivileges>\n"
    "                <requestedExecutionLevel level='asInvoker' uiAccess='false' />\n"
    "            </requestedPrivileges>\n"
    "        </security>\n"
    "    </trustInfo>\n"
#endif
    "</assembly>\n"
END

VERSION 0x20241222UL

// https://msdn.microsoft.com/en-us/library/aa381058.aspx
// https://msdn.microsoft.com/en-us/library/aa381049.aspx
// https://msdn.microsoft.com/en-us/library/aa381057.aspx

VS_VERSION_INFO VERSIONINFO
FILEFLAGS       VS_FF_PRIVATEBUILD | VS_FF_SPECIALBUILD
FILEFLAGSMASK   VS_FFI_FILEFLAGSMASK
FILEOS          VOS_NT_WINDOWS32
FILETYPE        VFT_APP
FILESUBTYPE     VFT2_UNKNOWN
FILEVERSION     0,8,15,0
PRODUCTVERSION  0,8,15,0
BEGIN
    BLOCK "StringFileInfo"
    BEGIN
#ifdef UNICODE
        BLOCK "040904B0"
#else
        BLOCK "040904E4"
#endif
        BEGIN
            VALUE "Comments",         "https://meltdownattack.com/index.html"
            VALUE "CompanyName",      "eSKamation\n"
                                      "https://skanthak.hier-im-netz.de/gimmick.html"
            VALUE "FileDescription",  "Meltdown (CVE-2017-5754 [Rogue Data Cache Load]) Update Check Utility"
            VALUE "FileVersion",      "0.8.15.0"
            VALUE "InternalName",     "MELTDOWN"
            VALUE "LegalCopyright",   "Copyright  2018-2024, Stefan Kanthak"
        //  VALUE "LegalTrademarks",  ""
        //  VALUE "OLESelfRegister",  "Disabled"
            VALUE "OriginalFilename", "MELTDOWN.EXE"
            VALUE "PrivateBuild",     "NOMSVCRT"
            VALUE "ProductName",      "Meltdown Update Check Utility"
            VALUE "ProductVersion",   "0.8.15.0"
            VALUE "SpecialBuild",     "Release"
        END
    END
    BLOCK "VarFileInfo"
    BEGIN
#ifdef UNICODE
        VALUE "Translation", 0x0409, 1200
#else
        VALUE "Translation", 0x0409, 1252
#endif
    END
END
<<NOKEEP

SPECTRE.RES: SPECTRE.ICO GIMMICK.MAK
	RC.EXE /DUNICODE /Fo$@ /L 0 /N /R /V <<
// Copyright (C) 2018-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

// https://msdn.microsoft.com/en-us/library/aa383732.aspx

#define STRICT

#include <winnt.h>
#include <winuser.h>
#include <winver.h>

LANGUAGE LANG_NEUTRAL, SUBLANG_NEUTRAL

1 ICON "SPECTRE.ICO"	// https://spectreattack.com/favicon.ico

// https://msdn.microsoft.com/en-us/library/dn481241.aspx
// https://msdn.microsoft.com/en-us/library/dd371711.aspx

CREATEPROCESS_MANIFEST_RESOURCE_ID RT_MANIFEST
BEGIN
#ifdef UTF8BOM
    // https://msdn.microsoft.com/en-us/library/dd374101.aspx

    "\xEF\xBB\xBF"
#endif
    // BUG: the module loader fails with STATUS_SXS_CANT_GEN_ACTCTX
    //      when a valid encoding other than 'UTF-8' is specified!
#ifdef UTF8XML
    "<?xml version='1.0' encoding='UTF-8' standalone='yes' ?>\n"
#endif
    "<!-- Copyright (C) 2018-2024, Stefan Kanthak -->\n"
    "<assembly manifestVersion='1.0' xmlns='urn:schemas-microsoft-com:asm.v1'>\n"
    "    <assemblyIdentity name='eSKamation.Utility.Spectre' processorArchitecture='*' type='win32' version='0.8.15.0' />\n"
    "    <compatibility xmlns='urn:schemas-microsoft-com:compatibility.v1'>\n"
    "        <application>\n"
    "            <supportedOS Id='{e2011457-1546-43c5-a5fe-008deee3d3f0}' />\n" // NT 6.0
    "            <supportedOS Id='{35138b9a-5d96-4fbd-8e2d-a2440225f93a}' />\n" // NT 6.1
    "            <supportedOS Id='{4a2f28e3-53b9-4441-ba9c-d69d4a4a6e38}' />\n" // NT 6.2
    "            <supportedOS Id='{1f676c76-80e1-4239-95bb-83d0f6d0da78}' />\n" // NT 6.3
    "            <supportedOS Id='{8e0f7a12-bfb3-4fe8-b9a5-48fd50a15a9a}' />\n" // NT 10
    "        </application>\n"
    "    </compatibility>\n"
    "    <description>Spectre Update Check Utility</description>\n"
#if 0
    "    <trustInfo xmlns='urn:schemas-microsoft-com:asm.v2'>\n"
    "        <security>\n"
    "            <requestedPrivileges>\n"
    "                <requestedExecutionLevel level='asInvoker' uiAccess='false' />\n"
    "            </requestedPrivileges>\n"
    "        </security>\n"
    "    </trustInfo>\n"
#endif
    "</assembly>\n"
END

VERSION 0x20241222UL

// https://msdn.microsoft.com/en-us/library/aa381058.aspx
// https://msdn.microsoft.com/en-us/library/aa381049.aspx
// https://msdn.microsoft.com/en-us/library/aa381057.aspx

VS_VERSION_INFO VERSIONINFO
FILEFLAGS       VS_FF_PRIVATEBUILD | VS_FF_SPECIALBUILD
FILEFLAGSMASK   VS_FFI_FILEFLAGSMASK
FILEOS          VOS_NT_WINDOWS32
FILETYPE        VFT_APP
FILESUBTYPE     VFT2_UNKNOWN
FILEVERSION     0,8,15,0
PRODUCTVERSION  0,8,15,0
BEGIN
    BLOCK "StringFileInfo"
    BEGIN
#ifdef UNICODE
        BLOCK "040904B0"
#else
        BLOCK "040904E4"
#endif
        BEGIN
            VALUE "Comments",         "https://spectreattack.com/index.html\n"
                                      "https://www.intel.com/content/www/us/en/security-center/advisory/intel-sa-00088.html"
            VALUE "CompanyName",      "eSKamation\n"
                                      "https://skanthak.hier-im-netz.de/gimmick.html"
            VALUE "FileDescription",  "Spectre (CVE-2017-5715 [Branch Target Injection] & CVE-2017-5753 [Bounds Check Bypass]) Update Check Utility"
            VALUE "FileVersion",      "0.8.15.0"
            VALUE "InternalName",     "SPECTRE"
            VALUE "LegalCopyright",   "Copyright  2018-2024, Stefan Kanthak"
        //  VALUE "LegalTrademarks",  ""
        //  VALUE "OLESelfRegister",  "Disabled"
            VALUE "OriginalFilename", "SPECTRE.EXE"
            VALUE "PrivateBuild",     "NOMSVCRT"
            VALUE "ProductName",      "Spectre Update Check Utility"
            VALUE "ProductVersion",   "0.8.15.0"
            VALUE "SpecialBuild",     "Release"
        END
    END
    BLOCK "VarFileInfo"
    BEGIN
#ifdef UNICODE
        VALUE "Translation", 0x0409, 1200
#else
        VALUE "Translation", 0x0409, 1252
#endif
    END
END
<<NOKEEP

VARIANT4.RES: GIMMICK.ICO GIMMICK.MAK
	RC.EXE /DUNICODE /Fo$@ /L 0 /N /R /V <<
// Copyright (C) 2018-2024, Stefan Kanthak <stefan.kanthak@nexgo.de>

// https://msdn.microsoft.com/en-us/library/7f0aews7.aspx

#pragma comment(compiler)

// https://msdn.microsoft.com/en-us/library/aa383732.aspx

#define STRICT

#include <winnt.h>
#include <winuser.h>
#include <winver.h>

LANGUAGE LANG_NEUTRAL, SUBLANG_NEUTRAL

1 ICON "GIMMICK.ICO"	// https://skanthak.hier-im-netz.de/favicon.ico

// https://msdn.microsoft.com/en-us/library/dn481241.aspx
// https://msdn.microsoft.com/en-us/library/dd371711.aspx

CREATEPROCESS_MANIFEST_RESOURCE_ID RT_MANIFEST
BEGIN
#ifdef UTF8BOM
    // https://msdn.microsoft.com/en-us/library/dd374101.aspx

    "\xEF\xBB\xBF"
#endif
    // BUG: the module loader fails with STATUS_SXS_CANT_GEN_ACTCTX
    //      when a valid encoding other than 'UTF-8' is specified!
#ifdef UTF8XML
    "<?xml version='1.0' encoding='UTF-8' standalone='yes' ?>\n"
#endif
    "<!-- Copyright (C) 2018-2024, Stefan Kanthak -->\n"
    "<assembly manifestVersion='1.0'xmlns='urn:schemas-microsoft-com:asm.v1'>\n"
    "    <assemblyIdentity name='eSKamation.Utility.Variant4' processorArchitecture='*' type='win32' version='0.8.15.0' />\n"
    "    <compatibility xmlns='urn:schemas-microsoft-com:compatibility.v1'>\n"
    "        <application>\n"
    "            <supportedOS Id='{e2011457-1546-43c5-a5fe-008deee3d3f0}' />\n" // NT 6.0
    "            <supportedOS Id='{35138b9a-5d96-4fbd-8e2d-a2440225f93a}' />\n" // NT 6.1
    "            <supportedOS Id='{4a2f28e3-53b9-4441-ba9c-d69d4a4a6e38}' />\n" // NT 6.2
    "            <supportedOS Id='{1f676c76-80e1-4239-95bb-83d0f6d0da78}' />\n" // NT 6.3
    "            <supportedOS Id='{8e0f7a12-bfb3-4fe8-b9a5-48fd50a15a9a}' />\n" // NT 10
    "        </application>\n"
    "    </compatibility>\n"
    "    <description>Variant 4 Update Check Utility</description>\n"
#if 0
    "    <trustInfo xmlns='urn:schemas-microsoft-com:asm.v2'>\n"
    "        <security>\n"
    "            <requestedPrivileges>\n"
    "                <requestedExecutionLevel level='asInvoker' uiAccess='false' />\n"
    "            </requestedPrivileges>\n"
    "        </security>\n"
    "    </trustInfo>\n"
#endif
    "</assembly>\n"
END

VERSION 0x20241222UL

// https://msdn.microsoft.com/en-us/library/aa381058.aspx
// https://msdn.microsoft.com/en-us/library/aa381049.aspx
// https://msdn.microsoft.com/en-us/library/aa381057.aspx

VS_VERSION_INFO VERSIONINFO
FILEFLAGS       VS_FF_PRIVATEBUILD | VS_FF_SPECIALBUILD
FILEFLAGSMASK   VS_FFI_FILEFLAGSMASK
FILEOS          VOS_NT_WINDOWS32
FILETYPE        VFT_APP
FILESUBTYPE     VFT2_UNKNOWN
FILEVERSION     0,8,15,0
PRODUCTVERSION  0,8,15,0
BEGIN
    BLOCK "StringFileInfo"
    BEGIN
#ifdef UNICODE
        BLOCK "040904B0"
#else
        BLOCK "040904E4"
#endif
        BEGIN
            VALUE "Comments",         "https://www.intel.com/content/www/us/en/security-center/advisory/intel-sa-00115.html"
            VALUE "CompanyName",      "eSKamation\n"
                                      "https://skanthak.hier-im-netz.de/gimmick.html"
            VALUE "FileDescription",  "Variant 4 (CVE-2018-3639 [Speculative Store Bypass]) Update Check Utility"
            VALUE "FileVersion",      "0.8.15.0"
            VALUE "InternalName",     "VARIANT4"
            VALUE "LegalCopyright",   "Copyright  2018-2024, Stefan Kanthak"
        //  VALUE "LegalTrademarks",  ""
        //  VALUE "OLESelfRegister",  "Disabled"
            VALUE "OriginalFilename", "VARIANT4.EXE"
            VALUE "PrivateBuild",     "NOMSVCRT"
            VALUE "ProductName",      "Variant 4 Update Check Utility"
            VALUE "ProductVersion",   "0.8.15.0"
            VALUE "SpecialBuild",     "Release"
        END
    END
    BLOCK "VarFileInfo"
    BEGIN
#ifdef UNICODE
        VALUE "Translation", 0x0409, 1200
#else
        VALUE "Translation", 0x0409, 1252
#endif
    END
END
<<NOKEEP
